$switch-open: #4cd964;

// Reference:
// http://www.google.com/design/spec/components/text-fields.html
.with-floating-label {
  min-height: 55px;
  
  .floating-label {
    @include font-size(16);
    @include transition(top $transition-duration ease-in-out, color $transition-duration ease-in-out, font-size 200ms ease-in-out);
    color: $medium-gray;
    margin: 0 0 auto 8px;
    position: absolute;
    top: 4px;
  }

  // uncomment the components you want the side validation icon to be shown
  [type='text'],
  [type='password'],
  [type='date'],
  // [type='datetime'],
  // [type='datetime-local'],
  // [type='month'],
  // [type='week'],
  [type='email'],
  // [type='number'],
  // [type='search'],
  // [type='tel'],
  // [type='time'],
  // [type='url'],
  // [type='color'],
  textarea,
  select {
    &:focus,
    &:valid,
    &:invalid:not(:placeholder-shown) {
      & + .field-state .floating-label {
        @include font-size(11);
        top: -15px;
      }
    }

    &:focus {
      border-bottom: 1px solid $dark-gray;
    }

    // valid state validation icon controls shame @icons
    &:valid:not(select):not([type='date']) { //on type checks for valid state
      & + .field-state {
        @extend .field-state-success;
      }

      &:focus { // valid and focused
        border-color: $valid-color;

        & + .field-state .floating-label { // label color on valid
          color: $valid-color;
        }
      }

      // form field renders valid but abide invalid 
      & ~ .form-error.is-visible {
        display: none!important;
      }

  }

    &:invalid { //on type checks for invalid state

      &:not(:focus):not(:placeholder-shown):not(select):not([type='date']) + .field-state { // not in initial state
        @extend .field-state-error;
      }

      &:focus { // invalid and focused
        border-color: $invalid-color;

        &:not(select):not([type='date']) + .field-state {
          @extend .field-state-warning;
        }

        & + .field-state .floating-label { // label color on invalid
          color: $invalid-color;
        }

        & ~ .reminder {
          @extend .mod_reminder-on;
        }
      }
  }

    // move the vis-toggle to right when warning icon 
    &:valid,
    &:focus,
    &:invalid:not(:placeholder-shown) {
      & + .field-state .vis-togglers {
        right: 28px;
      }
    }

    } // end of form elements customization
}

//switch fixes

input {
  ~ .switch-paddle {
    background-color: $light-gray;
    border-radius: 20px;
    text-align: right;

    &::after {
      // border: 1px solid $medium-gray;
      border-radius: 100%;
      box-sizing: border-box;
    }
  }

  &.is-invalid-input ~ .switch-paddle {
    // background-color: $invalid-color;
    
  }

  &:checked ~ .switch-paddle {
    background-color: $switch-open;
    // background-color: $valid-color;
    &::after {
      border: 1px solid darkgreen inset;
      border-radius: 100%;
    }
  }
}

//dropdown pink error bg fix
.is-invalid-input:not(:focus) {
  background-color: transparent;
}
